<script setup lang="ts">
import { nextTick, onMounted, ref } from 'vue'
import type { Bills } from '@/types/Bills'
import { useBillsStore } from '@/stores/bills'
import type { VForm } from 'vuetify/components'

const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'totalPrice',
    key: 'totalPrice',
    value: 'totalPrice'
  },
  {
    title: 'date',
    key: 'date',
    value: 'date'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

const billsStore = useBillsStore()

const dialog = ref(false)
const dialogDelete = ref(false)
const form = ref(false)
const loading = ref(false)
const refform = ref<VForm | null>(null)

async function editItem(item: Bills) {
  if (!item.id) return
  await billsStore.getBill_p(item.id)
  dialog.value = true
}

async function deleteItem(item: Bills) {
  if (!item.id) return
  await billsStore.getBill_p(item.id)
  dialogDelete.value = true
}

async function deleteItemConfirm() {
  await billsStore.deleteBill_p()
  closeDelete()
}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    billsStore.clearForm_p()
  })
}

function onSubmit() {}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    billsStore.clearForm_p()
  })
}

async function save() {
  const { valid } = await refform.value!.validate()
  if (!valid) return
  await billsStore.saveBill_p()
  closeDialog()
}

onMounted(async () => {
  await billsStore.getBills_p()
})
</script>

<template>
  <div>
    <v-data-table :headers="headers" :items="billsStore.bills_p" height="664">
      <template v-slot:top>
        <v-toolbar flat style="background-color: #282828; color: white">
          <v-toolbar-title>Place Bills</v-toolbar-title>
          <v-dialog v-model="dialog" persistent width="500">
            <template v-slot:activator="{ props }">
              <v-btn v-bind="props" style="background-color: #c7a17a" color="white">
                New Place Bills
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Place Bills</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refform" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="12">
                        <v-text-field
                          v-model="billsStore.editedBill_p.totalPrice"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please fill data']"
                          class="mb-2"
                          clearable
                          label="Total Price"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="12">
                        <v-text-field
                          v-model="billsStore.editedBill_p.date"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please fill data']"
                          class="mb-2"
                          clearable
                          label="Date"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small style="color: red">*Please fill data</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="primary" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="primary" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" v-model="dialog" @click="editItem(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" v-model="dialogDelete" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
    </v-data-table>
  </div>

  <v-dialog v-model="dialogDelete" width="500px">
    <v-card>
      <br />
      <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
      <v-spacer></v-spacer>
      <v-card-title align="center" class="text-h5">Are you sure?</v-card-title>
      <v-card-title align="center" class="text-h10">
        This action cannot be undone.<br />
        All values associated with this field will be lost.
      </v-card-title>
      <v-spacer></v-spacer>
      <div align="center">
        <div style="margin: 0 auto; max-width: 400px">
          <v-btn
            block
            style="background-color: #e11d48"
            color="white"
            variant="text"
            @click="deleteItemConfirm()"
          >
            Delete field
          </v-btn>
        </div>
      </div>
      <div align="center">
        <div
          style="
            margin: 0 auto;
            max-width: 400px;
            border: 1px solid #dfe1e6;
            border-radius: 5px;
            margin-top: 10px;
          "
        >
          <v-btn block color="primary" variant="text" @click="closeDelete()"> Cancel </v-btn>
        </div>
      </div>
      <v-spacer></v-spacer>
      <br />
    </v-card>
  </v-dialog>
</template>

<style scoped></style>
